-- Filters Emotes from opposing faction

-- Races based on their localization independant name.
local hordeRaces = {
	["BloodElf"]	         = 1,
	["Goblin"]		         = 1,
	["HighmountainTauren"] = 1,
	["MagharOrc"]          = 1,
	["Nightborne"]         = 1,
	["Orc"]				         = 1,	
	["Tauren"] 		         = 1,
	["Troll"]			         = 1,
	["Undead"]		         = 1,
	["Scourge"]            = 1,
	["Vulpera"]            = 1,
	["ZandalariTroll"]     = 1,
}

-- Races based on their localization independant name.
local allianceRaces = {
	["DarkIronDwarf"]      = 1,
	["Draenei"]		         = 1,
	["Dwarf"]			         = 1,
	["Gnome"] 		         = 1,
	["Human"]			         = 1,
	["LightforgedDraenei"] = 1,
	["KulTiran"]           = 1,
	["Mechagnome"]         = 1,
	["NightElf"]	         = 1,
	["ThinHuman"]          = 1,
	["VoidElf"]            = 1,
	["Worgen"]		         = 1,
}

local opposingRaces = UnitFactionGroup("player") == "Horde"
	and allianceRaces or hordeRaces

function FilterOpposingFactionSpeech(self, event, msg, sender, language, ...)
	local guid = select(9,...)
	if guid then
		local race = select(4, GetPlayerInfoByGUID(guid))
		if race and opposingRaces[race] then
			return 1
		end
		if race == "Pandaren" then
			if UnitFactionGroup("player") == "Horde"    and language == "Common" then
				return 1
			end
			if UnitFactionGroup("player") == "Alliance" and language == "Orcish" then
				return 1
			end
		end
	end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_EMOTE",
	FilterOpposingFactionSpeech)
ChatFrame_AddMessageEventFilter("CHAT_MSG_TEXT_EMOTE",
	FilterOpposingFactionSpeech)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL",
	FilterOpposingFactionSpeech)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY",
	FilterOpposingFactionSpeech)